// Code generated by goa v3.12.3, DO NOT EDIT.
//
// taskList HTTP client encoders and decoders
//
// Command:
// $ goa gen gitlab.eclipse.org/eclipse/xfsc/tsa/task/design

package client

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"

	tasklist "gitlab.eclipse.org/eclipse/xfsc/tsa/task/gen/task_list"
	goahttp "goa.design/goa/v3/http"
)

// BuildCreateRequest instantiates a HTTP request object with method and path
// set to call the "taskList" service "Create" endpoint
func (c *Client) BuildCreateRequest(ctx context.Context, v any) (*http.Request, error) {
	var (
		taskListName string
	)
	{
		p, ok := v.(*tasklist.CreateTaskListRequest)
		if !ok {
			return nil, goahttp.ErrInvalidType("taskList", "Create", "*tasklist.CreateTaskListRequest", v)
		}
		taskListName = p.TaskListName
	}
	u := &url.URL{Scheme: c.scheme, Host: c.host, Path: CreateTaskListPath(taskListName)}
	req, err := http.NewRequest("POST", u.String(), nil)
	if err != nil {
		return nil, goahttp.ErrInvalidURL("taskList", "Create", u.String(), err)
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}

	return req, nil
}

// EncodeCreateRequest returns an encoder for requests sent to the taskList
// Create server.
func EncodeCreateRequest(encoder func(*http.Request) goahttp.Encoder) func(*http.Request, any) error {
	return func(req *http.Request, v any) error {
		p, ok := v.(*tasklist.CreateTaskListRequest)
		if !ok {
			return goahttp.ErrInvalidType("taskList", "Create", "*tasklist.CreateTaskListRequest", v)
		}
		if p.CacheNamespace != nil {
			head := *p.CacheNamespace
			req.Header.Set("x-cache-namespace", head)
		}
		if p.CacheScope != nil {
			head := *p.CacheScope
			req.Header.Set("x-cache-scope", head)
		}
		body := p.Data
		if err := encoder(req).Encode(&body); err != nil {
			return goahttp.ErrEncodingError("taskList", "Create", err)
		}
		return nil
	}
}

// DecodeCreateResponse returns a decoder for responses returned by the
// taskList Create endpoint. restoreBody controls whether the response body
// should be restored after having been read.
func DecodeCreateResponse(decoder func(*http.Response) goahttp.Decoder, restoreBody bool) func(*http.Response) (any, error) {
	return func(resp *http.Response) (any, error) {
		if restoreBody {
			b, err := io.ReadAll(resp.Body)
			if err != nil {
				return nil, err
			}
			resp.Body = io.NopCloser(bytes.NewBuffer(b))
			defer func() {
				resp.Body = io.NopCloser(bytes.NewBuffer(b))
			}()
		} else {
			defer resp.Body.Close()
		}
		switch resp.StatusCode {
		case http.StatusOK:
			var (
				body CreateResponseBody
				err  error
			)
			err = decoder(resp).Decode(&body)
			if err != nil {
				return nil, goahttp.ErrDecodingError("taskList", "Create", err)
			}
			err = ValidateCreateResponseBody(&body)
			if err != nil {
				return nil, goahttp.ErrValidationError("taskList", "Create", err)
			}
			res := NewCreateTaskListResultOK(&body)
			return res, nil
		default:
			body, _ := io.ReadAll(resp.Body)
			return nil, goahttp.ErrInvalidResponse("taskList", "Create", resp.StatusCode, string(body))
		}
	}
}

// BuildTaskListStatusRequest instantiates a HTTP request object with method
// and path set to call the "taskList" service "TaskListStatus" endpoint
func (c *Client) BuildTaskListStatusRequest(ctx context.Context, v any) (*http.Request, error) {
	var (
		taskListID string
	)
	{
		p, ok := v.(*tasklist.TaskListStatusRequest)
		if !ok {
			return nil, goahttp.ErrInvalidType("taskList", "TaskListStatus", "*tasklist.TaskListStatusRequest", v)
		}
		taskListID = p.TaskListID
	}
	u := &url.URL{Scheme: c.scheme, Host: c.host, Path: TaskListStatusTaskListPath(taskListID)}
	req, err := http.NewRequest("GET", u.String(), nil)
	if err != nil {
		return nil, goahttp.ErrInvalidURL("taskList", "TaskListStatus", u.String(), err)
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}

	return req, nil
}

// DecodeTaskListStatusResponse returns a decoder for responses returned by the
// taskList TaskListStatus endpoint. restoreBody controls whether the response
// body should be restored after having been read.
func DecodeTaskListStatusResponse(decoder func(*http.Response) goahttp.Decoder, restoreBody bool) func(*http.Response) (any, error) {
	return func(resp *http.Response) (any, error) {
		if restoreBody {
			b, err := io.ReadAll(resp.Body)
			if err != nil {
				return nil, err
			}
			resp.Body = io.NopCloser(bytes.NewBuffer(b))
			defer func() {
				resp.Body = io.NopCloser(bytes.NewBuffer(b))
			}()
		} else {
			defer resp.Body.Close()
		}
		switch resp.StatusCode {
		case http.StatusMultiStatus:
			var (
				body TaskListStatusMultiStatusResponseBody
				err  error
			)
			err = decoder(resp).Decode(&body)
			if err != nil {
				return nil, goahttp.ErrDecodingError("taskList", "TaskListStatus", err)
			}
			err = ValidateTaskListStatusMultiStatusResponseBody(&body)
			if err != nil {
				return nil, goahttp.ErrValidationError("taskList", "TaskListStatus", err)
			}
			res := NewTaskListStatusResponseMultiStatus(&body)
			res.Status = "failed"
			return res, nil
		case http.StatusCreated:
			var (
				body TaskListStatusCreatedResponseBody
				err  error
			)
			err = decoder(resp).Decode(&body)
			if err != nil {
				return nil, goahttp.ErrDecodingError("taskList", "TaskListStatus", err)
			}
			err = ValidateTaskListStatusCreatedResponseBody(&body)
			if err != nil {
				return nil, goahttp.ErrValidationError("taskList", "TaskListStatus", err)
			}
			res := NewTaskListStatusResponseCreated(&body)
			res.Status = "created"
			return res, nil
		case http.StatusAccepted:
			var (
				body TaskListStatusAcceptedResponseBody
				err  error
			)
			err = decoder(resp).Decode(&body)
			if err != nil {
				return nil, goahttp.ErrDecodingError("taskList", "TaskListStatus", err)
			}
			err = ValidateTaskListStatusAcceptedResponseBody(&body)
			if err != nil {
				return nil, goahttp.ErrValidationError("taskList", "TaskListStatus", err)
			}
			res := NewTaskListStatusResponseAccepted(&body)
			res.Status = "pending"
			return res, nil
		case http.StatusOK:
			var (
				body TaskListStatusOKResponseBody
				err  error
			)
			err = decoder(resp).Decode(&body)
			if err != nil {
				return nil, goahttp.ErrDecodingError("taskList", "TaskListStatus", err)
			}
			err = ValidateTaskListStatusOKResponseBody(&body)
			if err != nil {
				return nil, goahttp.ErrValidationError("taskList", "TaskListStatus", err)
			}
			res := NewTaskListStatusResponseOK(&body)
			return res, nil
		default:
			body, _ := io.ReadAll(resp.Body)
			return nil, goahttp.ErrInvalidResponse("taskList", "TaskListStatus", resp.StatusCode, string(body))
		}
	}
}

// unmarshalGroupStatusResponseBodyToTasklistGroupStatus builds a value of type
// *tasklist.GroupStatus from a value of type *GroupStatusResponseBody.
func unmarshalGroupStatusResponseBodyToTasklistGroupStatus(v *GroupStatusResponseBody) *tasklist.GroupStatus {
	if v == nil {
		return nil
	}
	res := &tasklist.GroupStatus{
		ID:     v.ID,
		Status: v.Status,
	}
	if v.Tasks != nil {
		res.Tasks = make([]*tasklist.TaskStatus, len(v.Tasks))
		for i, val := range v.Tasks {
			res.Tasks[i] = unmarshalTaskStatusResponseBodyToTasklistTaskStatus(val)
		}
	}

	return res
}

// unmarshalTaskStatusResponseBodyToTasklistTaskStatus builds a value of type
// *tasklist.TaskStatus from a value of type *TaskStatusResponseBody.
func unmarshalTaskStatusResponseBodyToTasklistTaskStatus(v *TaskStatusResponseBody) *tasklist.TaskStatus {
	if v == nil {
		return nil
	}
	res := &tasklist.TaskStatus{
		ID:     v.ID,
		Status: v.Status,
	}

	return res
}
